// Bee Routines  - Jim Bumgardner
//
// Routines for animating a bee
//
// animation/acitivty states
BEE_IDLE = 0;
BEE_ROTATE = 1;
BEE_WALK = 2;
BEE_FLY  = 3;
NBR_BEE_STATES	= 4;

function Bee()
{
}

Bee.prototype = _root.attachMovie("bee", "bee_mc", 1);

function mover_idler()
{
	if (this._rotation > this.irange)
	{
		this._rotation--;
	}
	else if (this._rotation < -this.irange)
	{
		this._rotation++;
	}
	else {
		this._rotation *= this.idamp;
		this._rotation += Math.random()*this.iscale - this.iscale/2;
	}
}

function mover_flutterer()
{
	this._rotation += (this.irange - this._rotation)/2;
	if (this._yscale < 100)
		this._yscale = 100+this.iscale;
	else
		this._yscale = 100-this.iscale;
}


function mover_walk()
{
	// later, consider adding morph to walk...
	var r = getTimer()*.001/this.wfreq + this.wphase;
	r -= Math.floor(r);
	r = r*r*(3-2*r);	// ease
	this._rotation = Math.cos(r*2*Math.PI)*this.wrange;
	if (this.dox)
		this._xscale = 100+this.dox*this._rotation/this.wrange;
	if (this.doy)
		this._yscale = 100+this.doy*this._rotation/this.wrange;
}

function setup_idle(mc, irange, iscale, idamp)
{
	mc.irange = irange;
	mc.iscale = iscale;
	mc.idamp = idamp;
	// mc._xscale = 100;
	mc.onEnterFrame = mover_idler;
}

function setup_flutter(mc, irange, iscale, idamp)
{
	// mc._rotation = irange;
	mc.irange = irange;
	mc.iscale = iscale;
	mc.idamp = idamp;
	// mc._xscale = 100;
	mc.onEnterFrame = mover_flutterer;
}


function setup_walk(mc, wrange, wfreq, wphase)
{
	mc.wrange = wrange;
	mc.wfreq = wfreq;
	mc.wphase = wphase;
	mc.onEnterFrame = mover_walk;
}

kStdDamp	= 0.98;

Bee.prototype.setState = function(newState)
{
	this.state = newState;
		switch (this.state) {
		case BEE_IDLE:
			setup_idle(this.legs_1, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			setup_idle(this.legs_2, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			setup_idle(this.legs_3, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			setup_idle(this.legs_4, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			setup_idle(this.legs_5, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			setup_idle(this.legs_6, 60,3,kStdDamp);	this.legs_1._xscale = 100;

			setup_flutter(this.wing_1, 0,5,kStdDamp);
			setup_flutter(this.wing_2, 0,5,kStdDamp);

			setup_walk(this.head, 10,2,0);	this.head.doy = 10;	this.head.dox = 10;
			setup_walk(this.head.feeler_1, 30,5,0);
			setup_walk(this.head.feeler_2, 30,5,Math.PI/2);
			setup_idle(this.head.feeler_1.tip, 45,15,kStdDamp);
			setup_idle(this.head.feeler_2.tip, 45,15,kStdDamp);
			break;
		case BEE_ROTATE:
			setup_idle(this.legs_1, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			setup_walk(this.legs_2, 5, 0.5, 4/6);	this.legs_2.dox = 30;
			setup_walk(this.legs_3, 5, 0.5, 3/6);	this.legs_3.dox = 30;
			setup_walk(this.legs_4, 5, 0.5, 2/6);	this.legs_4.dox = 30;
			setup_walk(this.legs_5, 5, 0.5, 1/6);	this.legs_5.dox = 30;
			setup_idle(this.legs_6, 60,3,kStdDamp);	this.legs_1._xscale = 100;

			setup_flutter(this.wing_1, 0,5,kStdDamp);
			setup_flutter(this.wing_2, 0,5,kStdDamp);

			setup_walk(this.head, 10,2,0);	this.head.doy = 10;	this.head.dox = 10;
			setup_walk(this.head.feeler_1, 30,5,0);
			setup_walk(this.head.feeler_2, 30,5,Math.PI/2);
			setup_idle(this.head.feeler_1.tip, 45,15,kStdDamp);
			setup_idle(this.head.feeler_2.tip, 45,15,kStdDamp);
			break;
		case BEE_WALK:
			// setup_walk(this.legs_1, 5, 0.5, 0);		this.legs_1.dox = 10;
			setup_walk(this.legs_2, 5, 0.2, 1/6);	this.legs_2.dox = 30;
			setup_walk(this.legs_3, 5, 0.2, 2/6);	this.legs_3.dox = 30;
			setup_walk(this.legs_4, 5, 0.2, 3/6);	this.legs_4.dox = 30;
			setup_walk(this.legs_5, 5, 0.2, 4/6);	this.legs_5.dox = 30;
			// setup_walk(this.legs_6, 5, 0.5, 5/6);	this.legs_6.dox = 10;
			
			setup_flutter(this.wing_1, 0,5,kStdDamp);
			setup_flutter(this.wing_2, 0,5,kStdDamp);
			
			setup_idle(this.head, 45,1,kStdDamp);	this.head._yscale = 100;this.head._xscale = 100;
			setup_idle(this.head.feeler_1, 60,15,kStdDamp);
			setup_idle(this.head.feeler_2, 60,15,kStdDamp);
			setup_idle(this.head.feeler_1.tip, 45,15,kStdDamp);
			setup_idle(this.head.feeler_2.tip, 45,15,kStdDamp);
			break;

		case BEE_FLY:
			setup_idle(this.legs_2, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			setup_idle(this.legs_3, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			setup_idle(this.legs_4, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			setup_idle(this.legs_5, 60,3,kStdDamp);	this.legs_1._xscale = 100;
			
			setup_flutter(this.wing_1, -20, 20,kStdDamp);
			setup_flutter(this.wing_2, 20, 20,kStdDamp);
			
			setup_idle(this.head, 45,1,kStdDamp);	this.head._yscale = 100;this.head._xscale = 100;
			setup_idle(this.head.feeler_1, 60,15,kStdDamp);
			setup_idle(this.head.feeler_2, 60,15,kStdDamp);
			setup_idle(this.head.feeler_1.tip, 45,15,kStdDamp);
			setup_idle(this.head.feeler_2.tip, 45,15,kStdDamp);
			break;
		}
}


// Bee Navigation Functions

Bee.prototype.setTarget = function(tx,ty,compFunc,cfArg,locomotion)
{
	// trace("Setting target cell #" + cfArg + " at " + tx + "," + ty);
	this.tx = tx;
	this.ty = ty;
	this.locomotion = locomotion;
	this.hasTarget = true;
	this.compFunc = compFunc;
	this.cfArg = cfArg;
	this.setState(BEE_ROTATE);
	this.onEnterFrame = beeTargetIdle;
}

Bee.prototype.distToTarget = function()
{
	var dx = this.tx - this._x;
	var dy = this.ty - this._y;
	if (dx == 0 && dy == 0)
		return 0;
	else
		return Math.sqrt(dx*dx+dy*dy);
}

Bee.prototype.angleToTarget = function(dist)
{
	if (dist == 0)
		return 0;
	var dx = this.tx - this._x;
	var dy = this.ty - this._y;
	var a;
	if (dy < 0)
		a = Math.PI*2-Math.acos(dx/dist);
	else
		a = Math.acos(dx/dist);
	a = a*180/Math.PI - this._rotation;
	while (a > 180)
		a -= 360;
	while (a < -180)
		a += 360;
	// trace ("adiff = " + a);
	return a;
}

ROT_S = 4;
WALK_S = 2;
FLY_S = 5;

function beeTargetIdle()
{
	if (! this.hasTarget) {
			// shouldn't happen, unless target is cleared externally
			this.onEnterFrame = undefined;
	}
	else {
		var dist = this.distToTarget();
		if (dist < 1)
		{
			this.onEnterFrame = undefined;
			this.setState(BEE_IDLE);
			this.hasTarget = false;
			if (this.compFunc != undefined)
				this.compFunc(this.cfArg);
			return;
		}
		var dx = (this.tx - this._x)/dist;	// normalized vector
		var dy = (this.ty - this._y)/dist;
		switch (this.state) {
		case BEE_ROTATE:
			var da = this.angleToTarget(dist);
			if (Math.abs(da) < ROT_S+1)
				this.setState(this.locomotion);
			else if (Math.abs(da) < ROT_S)
				this._rotation += da;
			else
				this._rotation += (da > 0? ROT_S : -ROT_S);
			break;
		case BEE_WALK:
			// walking speed is 1
			dx *= WALK_S;	// flying speed
			dy *= WALK_S;
			if (dist < WALK_S*2) 	// ease in
			{
				dx *= dist/(WALK_S*2);
				dy *= dist/(WALK_S*2);
			}
			this._x += dx;
			this._y += dy;
			break;
		case BEE_FLY:
			dx *= FLY_S;	// flying speed
			dy *= FLY_S;
			if (dist < FLY_S*2) 	// ease in
			{
				this.setState(BEE_WALK);
			}
			this._x += dx;
			this._y += dy;
			break;
		}
	}
}

